# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices/configuration.html#application-related-configuration
parameters:
    client.default_language: "fr"
    client.protocol: "https"
    client.birthdate: 2021
    client.maintenance: true
    client.maintenance_lockpath: '%kernel.project_dir%/public/maintenance.lock'
    client.login: "app_profile"
    client.logout: "app_homepage"
    client.upload_dir: '%kernel.project_dir%/data/uploads'

services:
    Redis:
        class: Redis
        calls:
            - connect:
                - '%env(REDIS_HOST)%'
                - '%env(int:REDIS_PORT)%'
            - auth:
                - '%env(REDIS_PASSWORD)%'

    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.

        bind:
            $uploadDir: '%client.upload_dir%'

    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/'
        exclude:
            - '../src/DependencyInjection/'
            - '../src/Entity/'
            - '../src/Kernel.php'
            - '../src/Tests/'

    # controllers are imported separately to make sure services can be injected
    # as action arguments even if you don't extend any base controller class
    App\Controller\:
        resource: '../src/Controller/'
        tags: ['controller.service_arguments']

    #
    # User listener
    App\EntitySubscriber\UserEntitySubscriber:
        tags:
            - {name: 'doctrine.orm.entity_listener', event: 'prePersist' , entity: 'App\Entity\User'}
            - {name: 'doctrine.orm.entity_listener', event: 'preUpdate'  , entity: 'App\Entity\User'}
            - {name: 'doctrine.orm.entity_listener', event: 'postPersist', entity: 'App\Entity\User'}
            - {name: 'doctrine.orm.entity_listener', event: 'postUpdate' , entity: 'App\Entity\User'}
